<?php

declare(strict_types=1);

namespace Dedi\SyliusMigrationPlugin\Service\Specification;

use Dedi\SyliusMigrationPlugin\Definition\TableMappingDefinition;
use Dedi\SyliusMigrationPlugin\Dto\MigrationOption;

class IsDefinitionRunnable
{
    public function isSatisfiedBy(TableMappingDefinition $tableDefinition, MigrationOption $migrationOption): bool
    {
        if (null === $migrationOption->getTables() && null === $migrationOption->getGroup()) {
            return true;
        }

        if (null !== $migrationOption->getGroup()) {
            return null !== $tableDefinition->getGroup() && $migrationOption->getGroup() === $tableDefinition->getGroup();
        }

        return in_array($tableDefinition->getTargetTableName(), $migrationOption->getTables(), true);
    }
}
